### R code from vignette source 'DynTxRegime.Rnw'

###################################################
### code chunk number 1: DynTxRegime.Rnw:164-165
###################################################
options(width=70)


###################################################
### code chunk number 2: DynTxRegime.Rnw:169-170
###################################################
library( DynTxRegime )


###################################################
### code chunk number 3: DynTxRegime.Rnw:174-175
###################################################
data( bmiData )


###################################################
### code chunk number 4: DynTxRegime.Rnw:179-181
###################################################
dim( bmiData )
head( bmiData )


###################################################
### code chunk number 5: DynTxRegime.Rnw:185-187
###################################################
y <- -100*(bmiData$month12BMI -
           bmiData$baselineBMI)/bmiData$baselineBMI


###################################################
### code chunk number 6: bmi10
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <- 1
data$A1[ bmiData$A1=="CD" ] <- 0
data$A2[ bmiData$A2=="MR" ] <- 1
data$A2[ bmiData$A2=="CD" ] <- 0
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)


###################################################
### code chunk number 7: SSModels
###################################################
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))


###################################################
### code chunk number 8: DynTxRegime.Rnw:385-391
###################################################
moMainEx <- buildModelObj(model = ~ gender + A2*(parentBMI + month4BMI),
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContEx <- NULL


###################################################
### code chunk number 9: DynTxRegime.Rnw:396-398
###################################################
fitQ2 <- qLearn(moMain = moMainSS, moCont = moContSS,
                data = data, txName = 'A2', response = y)


###################################################
### code chunk number 10: DynTxRegime.Rnw:401-402
###################################################
is(fitQ2, "DynTxRegime")


###################################################
### code chunk number 11: FSModels
###################################################
moMainFS <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContFS <- buildModelObj(model = ~ gender + parentBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))


###################################################
### code chunk number 12: DynTxRegime.Rnw:426-429
###################################################
fitQ1 <- qLearn(moMain = moMainFS, moCont = moContFS,
                data = data, txName = 'A1', response = fitQ2,
                iter = 100L)


###################################################
### code chunk number 13: DynTxRegime.Rnw:470-472
###################################################
fitObjQ1 <- fitObject(fitQ1)
is(fitObjQ1, 'list')


###################################################
### code chunk number 14: DynTxRegime.Rnw:475-477
###################################################
names(fitObjQ1)
fitObjQ1


###################################################
### code chunk number 15: DynTxRegime.Rnw:482-484
###################################################
fitObjQ2 <- fitObject(fitQ2)
is(fitObjQ2, 'list')


###################################################
### code chunk number 16: DynTxRegime.Rnw:487-489
###################################################
names(fitObjQ2)
fitObjQ2


###################################################
### code chunk number 17: DynTxRegime.Rnw:496-499
###################################################
optQ2_testSet <- optTx(x=fitQ2)
head(optQ2_testSet$qFunctions)
head(optQ2_testSet$optimalTx)


###################################################
### code chunk number 18: DynTxRegime.Rnw:504-506
###################################################
qFuncsQ2 <- qFuncs(object = fitQ2)
head(qFuncsQ2)


###################################################
### code chunk number 19: DynTxRegime.Rnw:509-514
###################################################
optQ1_testSet <- optTx(x = fitQ1)
head(optQ1_testSet$qFunctions)
head(optQ1_testSet$optimalTx)
qFuncsQ1 <- qFuncs(object = fitQ1)
head(qFuncsQ1)


###################################################
### code chunk number 20: newPatientS1
###################################################
newpatient <- data.frame("gender" = 1, 
                         "race" = 1, 
                         "parentBMI" = 40, 
                         "baselineBMI" = 35)


###################################################
### code chunk number 21: DynTxRegime.Rnw:525-527
###################################################
optQ1 <- optTx(x = fitQ1, newdata = newpatient)
optQ1


###################################################
### code chunk number 22: newPatientS2
###################################################
newpatient <- cbind(newpatient, "A1" = optQ1$optimalTx, "month4BMI" = 25)


###################################################
### code chunk number 23: DynTxRegime.Rnw:536-538
###################################################
optQ2 <- optTx(x = fitQ2, newdata = newpatient)
optQ2


###################################################
### code chunk number 24: DynTxRegime.Rnw:549-553
###################################################
fSet <- function(data){
          if( data$A1 == 0L ) return( list("A", c(0L)) )
          if( data$A1 == 1L ) return( list("B", c(0L,1L)) )
        }


###################################################
### code chunk number 25: DynTxRegime.Rnw:558-563
###################################################
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

fitQ2_FS <- qLearn(moMain = moMainSS, moCont = moContSS,
                   data = data, txName = 'A2', response = y,
                   fSet = fSet)


###################################################
### code chunk number 26: DynTxRegime.Rnw:566-571
###################################################
moMainFS <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContFS <- buildModelObj(model = ~ gender + parentBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

fitQ1_FS <- qLearn(moMain = moMainFS, moCont = moContFS,
                   data = data, txName = 'A1', response = fitQ2_FS,
                   iter = 100L)


###################################################
### code chunk number 27: DynTxRegime.Rnw:575-576
###################################################
newpatient <- newpatient[,1:4,drop=FALSE]


###################################################
### code chunk number 28: DynTxRegime.Rnw:578-579
###################################################
newpatient


###################################################
### code chunk number 29: DynTxRegime.Rnw:582-584
###################################################
optQ1_FS <- optTx(x = fitQ1_FS, newdata = newpatient)
optQ1_FS


###################################################
### code chunk number 30: DynTxRegime.Rnw:587-588
###################################################
newpatient <- cbind(newpatient, "A1" = optQ1_FS$optimalTx, "month4BMI" = 25)


###################################################
### code chunk number 31: DynTxRegime.Rnw:591-593
###################################################
optQ2_FS <- optTx(x = fitQ2_FS, newdata = newpatient)
optQ2_FS


###################################################
### code chunk number 32: DynTxRegime.Rnw:600-602
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <- 1
data$A1[ bmiData$A1=="CD" ] <- 0
data$A2[ bmiData$A2=="MR" ] <- 1
data$A2[ bmiData$A2=="CD" ] <- 0
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)
data$R <- rbinom(nrow(data),1,0.5)


###################################################
### code chunk number 33: DynTxRegime.Rnw:605-609
###################################################
fSet <- function(data){
          if( data$R == 0L ) return(list("A",c(0L,1L)))
          if( data$R == 1L ) return(list("B",c(0L,1L)))
        }


###################################################
### code chunk number 34: DynTxRegime.Rnw:612-639
###################################################
moMain <- list()
moCont <- list()
#Models for subset data$R=0
moMain[[1]] <- buildModelObjSubset(model = ~ gender + parentBMI + month4BMI,
                                   subset = "A",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

moCont[[1]] <- buildModelObjSubset(model = ~ parentBMI + month4BMI,
                                   subset = "A",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

#Models for subset data$R=1
moMain[[2]] <- buildModelObjSubset(model = ~ gender + parentBMI + month4BMI,
                                   subset = "B",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

moCont[[2]] <- buildModelObjSubset(model = ~ parentBMI + month4BMI,
                                   subset = "B",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))


###################################################
### code chunk number 35: DynTxRegime.Rnw:642-645
###################################################
fitQ2_SM <- qLearn(moMain = moMain, moCont = moCont,
                   data = data, txName = 'A2', response = y,
                   fSet = fSet)


###################################################
### code chunk number 36: DynTxRegime.Rnw:648-649
###################################################
cfs <- coef(fitQ2_SM)


###################################################
### code chunk number 37: DynTxRegime.Rnw:652-653
###################################################
is(cfs,'list')


###################################################
### code chunk number 38: DynTxRegime.Rnw:656-657
###################################################
names(cfs)


###################################################
### code chunk number 39: DynTxRegime.Rnw:660-661
###################################################
cfs[["A"]]


###################################################
### code chunk number 40: DynTxRegime.Rnw:666-671 (eval = FALSE)
###################################################
## moMainFS <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
##                           solver.method = 'lm',
##                           predict.method = 'predict.lm',
##                           predict.args = list(type='response'))
## 
## moContFS <- buildModelObj(model = ~ gender + parentBMI,
##                           solver.method = 'lm',
##                           predict.method = 'predict.lm',
##                           predict.args = list(type='response'))
## 
## fitQ1_SM <- qLearn(moMain = moMainFS, moCont = moContFS,
##                    data = data, txName = 'A1', response = fitQ2_SM,
##                    iter = 100L)


###################################################
### code chunk number 41: bmi11
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <-  1
data$A1[ bmiData$A1=="CD" ] <- -1
data$A2[ bmiData$A2=="MR" ] <-  1
data$A2[ bmiData$A2=="CD" ] <- -1
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)


###################################################
### code chunk number 42: DynTxRegime.Rnw:802-803
###################################################
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))


###################################################
### code chunk number 43: DynTxRegime.Rnw:808-810
###################################################
fitIQ2 = iqLearnSS(moMain = moMainSS, moCont = moContSS, 
                   data = data, response = y, txName = 'A2')


###################################################
### code chunk number 44: DynTxRegime.Rnw:813-814
###################################################
is(fitIQ2,'DynTxRegime')


###################################################
### code chunk number 45: DynTxRegime.Rnw:820-821
###################################################
head(fittedMain(fitIQ2))


###################################################
### code chunk number 46: DynTxRegime.Rnw:824-828
###################################################
moMainFS <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContFS <- buildModelObj(model = ~ gender + parentBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))
fitIQ1main <- iqLearnFSM(moMain = moMainFS, moCont = moContFS, 
                         data = data, response = fitIQ2, txName = 'A1', 
                         iter = 100L)


###################################################
### code chunk number 47: DynTxRegime.Rnw:831-832
###################################################
is(fitIQ1main,'DynTxRegime')


###################################################
### code chunk number 48: DynTxRegime.Rnw:839-840
###################################################
head(fittedCont(fitIQ2))


###################################################
### code chunk number 49: DynTxRegime.Rnw:843-852
###################################################
moMainFSc <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                           solver.method = 'lm',
                           predict.method = 'predict.lm',
                           predict.args = list(type='response'))

moContFSc <- buildModelObj(model = ~ gender + parentBMI + baselineBMI,
                           solver.method = 'lm',
                           predict.method = 'predict.lm',
                           predict.args = list(type='response'))


###################################################
### code chunk number 50: DynTxRegime.Rnw:855-858
###################################################
fitIQ1cm <- iqLearnFSC(moMain = moMainFSc, moCont = moContFSc, 
                       data = data, response = fitIQ2, txName = 'A1', 
                       iter = 100L)


###################################################
### code chunk number 51: DynTxRegime.Rnw:861-862
###################################################
is(fitIQ1cm,'DynTxRegime')


###################################################
### code chunk number 52: DynTxRegime.Rnw:866-867
###################################################
fitIQ1var = iqLearnFSV(fitIQ1cm)


###################################################
### code chunk number 53: DynTxRegime.Rnw:870-871
###################################################
stdDev(fitIQ1var)


###################################################
### code chunk number 54: DynTxRegime.Rnw:874-889
###################################################
moMainFSv <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                           solver.method = 'lm',
                           predict.method = 'predict.lm',
                           predict.args = list(type='response'))

moContFSv <- buildModelObj(model = ~ parentBMI + baselineBMI,
                           solver.method = 'lm',
                           predict.method = 'predict.lm',
                           predict.args = list(type='response'))

fitIQ1var <- iqLearnFSV(object = fitIQ1cm,
                        moMain = moMainFSv, moCont = moContFSv,
                        data = data)

is(fitIQ1var,'DynTxRegime')


###################################################
### code chunk number 55: DynTxRegime.Rnw:895-896
###################################################
qqPlot (fitIQ1var)


###################################################
### code chunk number 56: DynTxRegime.Rnw:907-910
###################################################
optIQ1_testSet = optTx( x = fitIQ1main, y = fitIQ1cm, z = fitIQ1var, dens = "nonpar" )
head(optIQ1_testSet$qFunctions)  
head(optIQ1_testSet$optimalTx)  


###################################################
### code chunk number 57: DynTxRegime.Rnw:915-918
###################################################
optIQ2_testSet = optTx( x = fitIQ2 )  
head(optIQ2_testSet$qFunctions)  
head(optIQ2_testSet$optimalTx)  


###################################################
### code chunk number 58: DynTxRegime.Rnw:925-926
###################################################
newpatient <- newpatient[,1:4,drop=FALSE]


###################################################
### code chunk number 59: DynTxRegime.Rnw:928-929
###################################################
newpatient


###################################################
### code chunk number 60: DynTxRegime.Rnw:931-933
###################################################
optIQ1 = optTx(x = fitIQ1main, y = fitIQ1cm, z = fitIQ1var, dens = "nonpar", newdata = newpatient)
optIQ1


###################################################
### code chunk number 61: DynTxRegime.Rnw:938-939
###################################################
newpatient <- cbind(newpatient, "A1" = optIQ1$optimalTx, "month4BMI" = 25)


###################################################
### code chunk number 62: DynTxRegime.Rnw:942-944
###################################################
optIQ2 = optTx(x = fitIQ2, newdata = newpatient)
optIQ2


###################################################
### code chunk number 63: DynTxRegime.Rnw:965-968
###################################################
estVal = plugInValue(optTx1 = optIQ1_testSet$optimalTx, optTx2 = optIQ2_testSet$optimalTx, 
                     response = y, tx1 = data$A1, tx2 = data$A2)
estVal


###################################################
### code chunk number 64: DynTxRegime.Rnw:1090-1093
###################################################
data <- bmiData
data$A1 <- as.factor(data$A1)
data$A2 <- as.factor(data$A2)


###################################################
### code chunk number 65: DynTxRegime.Rnw:1096-1101
###################################################
moPropen <- buildModelObj(model = ~1,
                          solver.method = 'glm',
                          solver.args = list('family'='binomial'),
                          predict.method = 'predict.glm',
                          predict.args = list('type'='response'))


###################################################
### code chunk number 66: DynTxRegime.Rnw:1106-1107
###################################################
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))


###################################################
### code chunk number 67: DynTxRegime.Rnw:1110-1119
###################################################
regimes <- function(v1, v2, v3, data){
  temp <- logical(nrow(data))
  temp[data$A1 == "MR"] <- ((v1 + v2*data$month4BMI[data$A1 == "MR"] + v3) > 0)
  temp[data$A1 == "CD"] <- ((v1 + v2*data$month4BMI[data$A1 == "CD"]) > 0)

  tx <- rep("CD",nrow(data))
  tx[temp] <- "MR"
  return(tx)
}


###################################################
### code chunk number 68: DynTxRegime.Rnw:1122-1125
###################################################
c1 <- rep(-10,3)
c2 <- rep( 10,3)
Domains <- cbind(c1,c2)


###################################################
### code chunk number 69: DynTxRegime.Rnw:1128-1129
###################################################
sv <- rep(0,3)


###################################################
### code chunk number 70: DynTxRegime.Rnw:1132-1133
###################################################
psize <- 100


###################################################
### code chunk number 71: DynTxRegime.Rnw:1138-1143
###################################################
fitSeq <- optimalSeq(moPropen = moPropen, 
                     moMain = moMainSS, moCont = moContSS, 
                     data = data, response = y, txName = "A2", 
                     regimes = regimes, 
                     pop.size = psize, starting.values = sv, Domains = Domains)


###################################################
### code chunk number 72: DynTxRegime.Rnw:1150-1155
###################################################
fitSeqIPWE <- optimalSeq(moPropen = moPropen, 
                         moMain = NULL, moCont = NULL, 
                         data = data, response = y, txName = "A2", 
                         regimes = regimes, 
                         pop.size = psize, starting.values = sv, Domains = Domains)


###################################################
### code chunk number 73: DynTxRegime.Rnw:1161-1164
###################################################
est <- regimeCoef(fitSeq)
est <- est/sqrt(est %*% est)
est


###################################################
### code chunk number 74: DynTxRegime.Rnw:1168-1169
###################################################
estimator(fitSeq)


###################################################
### code chunk number 75: DynTxRegime.Rnw:1173-1174
###################################################
genetic(fitSeq)


###################################################
### code chunk number 76: DynTxRegime.Rnw:1179-1182
###################################################
fitO <- outcome(fitSeq)
names(fitO)
head(fitted.values(fitO[[ "Combined" ]]))


###################################################
### code chunk number 77: DynTxRegime.Rnw:1186-1188
###################################################
fitP <- propen(fitSeq)
head(fitted.values(fitP))


###################################################
### code chunk number 78: DynTxRegime.Rnw:1192-1193
###################################################
head(optTx(x=fitSeq))


###################################################
### code chunk number 79: DynTxRegime.Rnw:1198-1200
###################################################
optSeq <- optTx(x = fitSeq,newdata = newpatient)
optSeq


###################################################
### code chunk number 80: DynTxRegime.Rnw:1335-1336
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <- 1
data$A1[ bmiData$A1=="CD" ] <- 0
data$A2[ bmiData$A2=="MR" ] <- 1
data$A2[ bmiData$A2=="CD" ] <- 0
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)


###################################################
### code chunk number 81: DynTxRegime.Rnw:1339-1344
###################################################
moPropen <- buildModelObj(model = ~1,
                          solver.method = 'glm',
                          solver.args = list('family'='binomial'),
                          predict.method = 'predict.glm',
                          predict.args = list('type'='response'))


###################################################
### code chunk number 82: DynTxRegime.Rnw:1350-1351
###################################################
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))


###################################################
### code chunk number 83: DynTxRegime.Rnw:1355-1360
###################################################
library(rpart)
moClass <- buildModelObj(model = ~ parentBMI + month4BMI,
                         solver.method = 'rpart',
                         solver.args = list(method="class"),
                         predict.args = list(type='class'))


###################################################
### code chunk number 84: DynTxRegime.Rnw:1366-1370
###################################################
fitCl <- optimalClass(moPropen = moPropen, 
                      moMain = moMainSS, moCont = moContSS, 
                      moClass = moClass,
                      data = data, response = y, txName = "A2")


###################################################
### code chunk number 85: DynTxRegime.Rnw:1373-1374
###################################################
is(fitCl,'DynTxRegime')


###################################################
### code chunk number 86: DynTxRegime.Rnw:1377-1381
###################################################
fitClIPWE <- optimalClass(moPropen = moPropen, 
                          moMain = NULL, moCont = NULL, 
                          moClass = moClass,
                          data = data, response = y, txName = "A2")


###################################################
### code chunk number 87: DynTxRegime.Rnw:1387-1388
###################################################
estimator(fitCl)


###################################################
### code chunk number 88: DynTxRegime.Rnw:1391-1392
###################################################
classif(fitCl)


###################################################
### code chunk number 89: DynTxRegime.Rnw:1395-1397
###################################################
fitO <- outcome(fitCl)
head(fitted.values(fitO[[ "Combined" ]]))


###################################################
### code chunk number 90: DynTxRegime.Rnw:1400-1402
###################################################
fitP <- propen(fitCl)
head(fitted.values(fitP))


###################################################
### code chunk number 91: DynTxRegime.Rnw:1405-1406
###################################################
head(optTx(x=fitCl))


###################################################
### code chunk number 92: DynTxRegime.Rnw:1409-1410
###################################################
newpatient$A1=0


###################################################
### code chunk number 93: DynTxRegime.Rnw:1412-1415
###################################################
newpatient
optCl <- optTx(x=fitCl, newdata=newpatient)
optCl


###################################################
### code chunk number 94: DynTxRegime.Rnw:1582-1583
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <- 1
data$A1[ bmiData$A1=="CD" ] <- 0
data$A2[ bmiData$A2=="MR" ] <- 1
data$A2[ bmiData$A2=="CD" ] <- 0
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)


###################################################
### code chunk number 95: DynTxRegime.Rnw:1586-1597
###################################################
moPropen <- list()
moPropen[[1]] <- buildModelObj(model = ~1,
                               solver.method = 'glm',
                               solver.args = list(family='binomial'),
                               predict.method = 'predict.glm',
                               predict.args = list(type='response'))
moPropen[[2]] <- buildModelObj(model = ~1,
                               solver.method = 'glm',
                               solver.args = list(family='binomial'),
                               predict.method = 'predict.glm',
                               predict.args = list(type='response'))


###################################################
### code chunk number 96: DynTxRegime.Rnw:1602-1613
###################################################
#
#Models for first-stage regression
######
moMainFS <- buildModelObj(model = ~ gender + race + parentBMI + baselineBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContFS <- buildModelObj(model = ~ gender + parentBMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))
#
#Models for second-stage regression
######
moMainSS <- buildModelObj(model = ~ gender + parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moContSS <- buildModelObj(model = ~ parentBMI + month4BMI,
                          solver.method = 'lm',
                          predict.method = 'predict.lm',
                          predict.args = list(type='response'))

moMain <- list(moMainFS, moMainSS)
moCont <- list(moContFS, moContSS)


###################################################
### code chunk number 97: DynTxRegime.Rnw:1617-1624
###################################################
regimes <- list()
regimes[[1]] <- function(a, b, d, data){
                  as.numeric(a + b*data$parentBMI + d*data$baselineBMI > 0 )
                }
regimes[[2]] <- function(a, b, d, data){
                  as.numeric(a + b*data$month4BMI + d*data$A1 > 0 )
                }


###################################################
### code chunk number 98: DynTxRegime.Rnw:1628-1631
###################################################
c1 <- rep(-1000,6)
c2 <- rep( 1000,6)
Domains <- cbind(c1,c2)


###################################################
### code chunk number 99: DynTxRegime.Rnw:1634-1635
###################################################
sv <- (1:6)/10


###################################################
### code chunk number 100: DynTxRegime.Rnw:1638-1639
###################################################
psize <- 100


###################################################
### code chunk number 101: DynTxRegime.Rnw:1644-1649
###################################################
fitSeq2 <- optimalSeq(moPropen = moPropen, 
                     moMain = moMain, moCont = moCont,
                     data = data, response = y, txName = c("A1", "A2"), 
                     regimes = regimes, 
                     pop.size = psize, starting.values = sv, Domains = Domains)


###################################################
### code chunk number 102: DynTxRegime.Rnw:1652-1653
###################################################
is(fitSeq2,'DynTxRegime')


###################################################
### code chunk number 103: DynTxRegime.Rnw:1659-1664
###################################################
fitSeq2IPWE <- optimalSeq(moPropen = moPropen, 
                          moMain = NULL, moCont = NULL,
                          data = data, response = y, txName = c("A1", "A2"), 
                          regimes = regimes, 
                          pop.size = psize, starting.values = sv, Domains = Domains)


###################################################
### code chunk number 104: DynTxRegime.Rnw:1670-1674
###################################################
est <- regimeCoef(fitSeq2)
est[[1]] <- est[[1]]/sqrt(est[[1]] %*% est[[1]])
est[[2]] <- est[[2]]/sqrt(est[[2]] %*% est[[2]])
est


###################################################
### code chunk number 105: DynTxRegime.Rnw:1679-1681
###################################################
head(optTx(x = fitSeq2))
optTx(x = fitSeq2, newdata = newpatient)


###################################################
### code chunk number 106: DynTxRegime.Rnw:1689-1692
###################################################
data <- bmiData
data$A1[ bmiData$A1=="MR" ] <- 1
data$A1[ bmiData$A1=="CD" ] <- 0
data$A2[ bmiData$A2=="MR" ] <- 1
data$A2[ bmiData$A2=="CD" ] <- 0
data$A1 <- as.integer(data$A1)
data$A2 <- as.integer(data$A2)
data$R <- rbinom(nrow(data),1,0.5)
data$A2[data$R==0] <- 1L - data$A1[data$R==0]


###################################################
### code chunk number 107: DynTxRegime.Rnw:1699-1708
###################################################
fSet <- list()
fSet[[1]] <- function(data){
               if( data$baselineBMI < 37 ) return(list("g1", c(0,1) ) )
               if( data$baselineBMI >= 37 )return(list("g2", c(0,1) ) )
             }
fSet[[2]] <- function(data){
               if( data$R == 0L ) return(list("g3", c(0,1) ) )
               if( data$R == 1L ) return(list("g4", c(0,1) ) )
             }


###################################################
### code chunk number 108: DynTxRegime.Rnw:1712-1760
###################################################
moMain <- list()
moCont <- list()
#Models for second-stage outcome
moMain[[1]] <- buildModelObjSubset(model = ~ gender + parentBMI + month4BMI + A1,
                                   dp = 2,
                                   subset = c("g3","g4"),
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

moCont[[1]] <- buildModelObjSubset(model = ~ month4BMI + A1,
                                   dp = 2,
                                   subset = c("g3","g4"),
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

#Models for first-stage outcome for subset g1
moMain[[2]] <- buildModelObjSubset(model = ~ gender + race + parentBMI + 
                                             baselineBMI,
                                   dp = 1,
                                   subset = "g1",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

moCont[[2]] <- buildModelObjSubset(model = ~ parentBMI + baselineBMI,
                                   dp = 1,
                                   subset = "g1",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

#Models for first-stage outcome for subset g2
moMain[[3]] <- buildModelObjSubset(model = ~ gender + race + parentBMI + 
                                             baselineBMI,
                                   dp = 1,
                                   subset = "g2",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))

moCont[[3]] <- buildModelObjSubset(model = ~ parentBMI + baselineBMI,
                                   dp = 1,
                                   subset = "g2",
                                   solver.method = 'lm',
                                   predict.method = 'predict.lm',
                                   predict.args = list(type='response'))


###################################################
### code chunk number 109: DynTxRegime.Rnw:1766-1787
###################################################
library(nnet)

moPropen <- list()
moPropen[[1]] <- buildModelObjSubset(model = ~1,
                                     dp = 1,
                                     subset = "g1",
                                     solver.method = 'multinom',
                                     predict.method = 'predict',
                                     predict.args = list(type='probs'))
moPropen[[2]] <- buildModelObjSubset(model = ~1,
                                     dp = 1,
                                     subset = "g2",
                                     solver.method = 'multinom',
                                     predict.method = 'predict',
                                     predict.args = list(type='probs'))
moPropen[[3]] <- buildModelObjSubset(model = ~1,
                                     dp = 2,
                                     subset = c("g3","g4"),
                                     solver.method = 'multinom',
                                     predict.method = 'predict',
                                     predict.args = list(type='probs'))


###################################################
### code chunk number 110: DynTxRegime.Rnw:1791-1802
###################################################
regimes <- list()
regimes[[1]] <- function(a, b, d, data){
                  as.numeric(a + b*data$parentBMI + d*data$baselineBMI > 0 )
                }
regimes[[2]] <- function(a, b, d, data){
                  res <- numeric(nrow(data))
                  tst <- data$R < 0.5
                  res[tst] <- 1-data$A1[tst]
                  res[!tst] <- (a + b*data$month4BMI[!tst] + d*data$A1[!tst] > 0 )
                  return(res)
                }


###################################################
### code chunk number 111: DynTxRegime.Rnw:1806-1812
###################################################
fitSeq2_FS <- optimalSeq(moPropen = moPropen, 
                         moMain = moMain, moCont = moCont,
                         fSet = fSet,
                         data = data, response = y, txName = c("A1", "A2"), 
                         regimes = regimes, suppress = TRUE, 
                         pop.size = psize, starting.values = sv, Domains = Domains)


